summaryrefslogtreecommitdiffstats
path: root/coccinelle/run-coccinelle.sh
diff options
context:
space:
mode:
Diffstat (limited to 'coccinelle/run-coccinelle.sh')
-rwxr-xr-xcoccinelle/run-coccinelle.sh27
1 files changed, 27 insertions, 0 deletions
diff --git a/coccinelle/run-coccinelle.sh b/coccinelle/run-coccinelle.sh
new file mode 100755
index 0000000..22ab66d
--- /dev/null
+++ b/coccinelle/run-coccinelle.sh
@@ -0,0 +1,27 @@
+#!/bin/bash -e
+
+top="$(git rev-parse --show-toplevel)"
+files="$(git ls-files ':/*.[ch]')"
+args=
+
+case "$1" in
+ -i)
+ args="$args --in-place"
+ shift
+ ;;
+esac
+
+if ! parallel -h >/dev/null; then
+ echo 'Please install GNU parallel (package "parallel")'
+ exit 1
+fi
+
+for SCRIPT in ${@-$top/coccinelle/*.cocci} ; do
+ echo "--x-- Processing $SCRIPT --x--"
+ TMPFILE=`mktemp`
+ echo "+ spatch --sp-file $SCRIPT $args ..."
+ parallel --halt now,fail=1 --keep-order --noswap --max-args=20 \
+ spatch --sp-file $SCRIPT $args ::: $files \
+ 2>"$TMPFILE" || cat "$TMPFILE"
+ echo -e "--x-- Processed $SCRIPT --x--\n"
+done